module sepmodulekmeshp

!  Some quantities related to the mesh

   integer, pointer :: ichangeobst  ! if 1 a boundary has been changed
   integer, pointer :: ipstkmeshpar ! starting address of kmeshpar in kmesh
   integer, pointer :: kelgrp       ! sum over all standard elements of number
                                    ! of points in standard elements
   integer, pointer :: kelma        ! Indicates if kmesha has been
                                    ! filled or not (0)
   integer, pointer :: kelmaa       ! indicates if nmesh has been created
   integer, pointer :: kelmac       ! memory management reference number
                                    ! of KMESH part ac
   integer, pointer :: kelmad       ! memory management reference number
                                    ! of KMESH part ad
   integer, pointer :: kelmae       ! memory management reference number
                                    ! of KMESH part ae
   integer, pointer :: kelmaf       ! memory management reference number
                                    ! of KMESH part af
   integer, pointer :: kelmag       ! memory management reference number
                                    ! of KMESH part ag
   integer, pointer :: kelmak       ! memory management reference number
                                    ! of KMESH part ak
   integer, pointer :: kelmal       ! memory management reference number
                                    ! of KMESH part al
   integer, pointer :: kelman       ! memory management reference number
                                    ! of KMESH part an
   integer, pointer :: kelmb        ! Indicates if kmeshb has been filled
   integer, pointer :: kelmc        ! Indicates if kmesha has been filled
   integer, pointer :: kelmd        ! Indicates if kmeshd has been filled
   integer, pointer :: kelme        ! Indicates if kmeshe has been filled
   integer, pointer :: kelmf        ! Indicates if kmeshf has been filled
   integer, pointer :: kelmg        ! Indicates if kmeshg has been filled
   integer, pointer :: kelmh        ! Indicates if icurvsobst has been filled
   integer, pointer :: kelmi        ! Indicates if kmeshi has been filled
   integer, pointer :: kelmj        ! Indicates if kmeshj has been filled
   integer, pointer :: kelmk        ! Indicates if kmeshk has been filled
   integer, pointer :: kelml        ! Indicates if kmeshl has been filled
   integer, pointer :: kelmm        ! Indicates if kmeshm has been filled
   integer, pointer :: kelmn        ! Indicates if kmeshn has been filled
   integer, pointer :: kelmo        ! Indicates if kmesho has been filled
   integer, pointer :: kelmp        ! Indicates if elsize has been filled
   integer, pointer :: kelmq        ! Indicates if kmeshq has been filled
   integer, pointer :: kelmr        ! Indicates if kmeshr has been filled
   integer, pointer :: kelms        ! Indicates if kmeshs has been filled
   integer, pointer :: kelmt        ! Indicates if kmesht has been filled
   integer, pointer :: kelmu        ! Indicates if kmeshu has been filled
   integer, pointer :: kelmv        ! Indicates if kmeshv has been filled
   integer, pointer :: kelmw        ! Indicates if kmeshw has been filled
   integer, pointer :: kelmx        ! Indicates if kmeshx has been filled
   integer, pointer :: kelmxrl      ! Indicates if rmeshx has been filled
   integer, pointer :: kelmz        ! Indicates if kmeshz has been filled
   integer, pointer :: kmiinput     ! sequence number of iinput  for kmesh
   integer, pointer :: kmrinput     ! sequence number of rinput  for kmesh
   integer, pointer :: meshadapt    ! if 0 the mesh has not been adapted
   integer, pointer :: mmnormal     ! Memory management for array normal
   integer, pointer :: mmouter      ! Memory management sequence number of
                                    !  array outerboundary
   integer, pointer :: mmsurfnodes  ! Memory management for array surfnodes
   integer, pointer :: ncurvs       ! Number of curves
   integer, pointer :: ndim         ! Dimension of the space
   integer, pointer :: nelem        ! Number of elements
   integer, pointer :: nelgrp       ! number of element groups
   integer, pointer :: nextpnt      ! number of extra points
   integer, pointer :: nlevel       ! number of levels
   integer, pointer :: nlevelsets   ! number of different level set functions
   integer, pointer :: npelm        ! Maximal number of points per element
   integer, pointer :: npoint       ! Number of nodes
   integer, pointer :: nsplit       ! Number of parts into which the mesh has
                                    ! been split
   integer, pointer :: nuspnt       ! Number of user points
   integer, pointer :: nsurfs       ! number of surfaces
   integer, pointer :: numobst      ! number of obstacles
   integer, pointer :: nvolms       ! number of volumes

end module sepmodulekmeshp
