module sepmoduleplotfn

!  Module for subroutine prplotfn

   use sepmodulemnsub
   use sepmoduletypes
   use sepmoduletime
   use sepmodulekmesh
   use sepmoduleconsts
   use sepmoduleplot

   integer :: idegfd          ! Degree of freedom sequence number
   integer :: ipoint(100)     ! Array of length nparts+1 containing the starting
                              ! addresses in array inodes of the various parts
                              ! the boundary consists of.
                              ! ipoint(1) = 1,
                              ! number of nodes at part i = ipoint(i+1)-ipoint(i)
   integer :: istartcur       ! starting position of curves in inpsep
   integer :: istartvecs      ! starting position of vector sequence numbers in
                              ! inpsep
   integer :: nnodes          ! Number of nodes
   integer :: nparts          ! umber of parts the boundary consists of
   integer :: numvecs         ! Number of vectors to be plotted

   character (len=80) textaxis(2)  ! text to be plotted along the axis

   double precision, allocatable :: funcx(:)   ! x-coordinates of the functions
   double precision, allocatable :: funcy(:,:) ! y-coordinates of the functions

end module sepmoduleplotfn
