module sepmodulestrings

!  --- A number of strings for reading

   integer, parameter :: nncodeprob=22
   integer, parameter :: nncodestressbn=7
   integer, parameter :: nncodestressmod=8
   integer, parameter :: nncodestress=37
   integer, parameter :: nncodemodel=6
   integer, parameter :: nncodenavstoks=19
   integer, parameter :: nncodenatbnd=3
   integer, parameter :: nncodereynolds=20
   integer, parameter :: nncodereynoldsbn=3
   integer, parameter :: nncodelinear=4
   integer, parameter :: nncodelin=2
   integer, parameter :: nncodebear=3
   integer, parameter :: nncodeupw=13, nncodecsys=3, nncodecompr=4
   integer, parameter :: nncodecont=5
   integer, parameter :: nncodediffus=10, nncodevel=4, nncodeapply=3
   integer, parameter :: nncodegen=10, nncodemech = 3, nncodetim=44
   integer, parameter :: nncodetimmeth=16, nncodevar = 3, nncodetimbc=4
   integer, parameter :: nncodestop=3
   integer, parameter :: nncodeitmeth=30
   integer, parameter :: nncodeprec=19
   integer, parameter :: nncodestart=3, istcodestart=nncodeprec+1
   integer, parameter :: nncodeterm=4, istcodeterm=istcodestart+nncodestart
   integer, parameter :: nncodeerr=2, istcodeerr=istcodeterm+nncodeterm
   integer, parameter :: nncodeprojm=2, istcodeprojm=istcodeerr+nncodeerr
   integer, parameter :: nncodeprojk=3, istcodeprojk=istcodeprojm+nncodeprojm
   integer, parameter :: nncodetyps=4, istcodetyps=istcodeprojk+nncodeprojk
   integer, parameter :: nncodedefl=2, istcodedefl=istcodetyps+nncodetyps
   integer, parameter :: nncodeprojme=3, istcodeprojme=istcodedefl+nncodedefl
   integer, parameter :: nncodeprojv=2, istcodeprojv=istcodeprojme+nncodeprojme
   integer, parameter :: nncodeparp=2, istcodeparp=istcodeprojv+nncodeprojv
   integer, parameter :: nncodeparsh=2, istcodeparsh=istcodeparp+nncodeparp
   integer, parameter :: nncodeparso=2, istcodeparso=istcodeparsh+nncodeparsh
   integer, parameter :: nncodepreca=istcodeparso+nncodeparso-1
   integer, parameter :: nncoderenum=4
   integer :: ncodeupw(nncodeupw), ncodecsys(nncodecsys), &
              ncodecompr(nncodecompr), ncodeapply(nncodeapply)
   integer :: ncodecont(nncodecont), nscodecont(nncodecont)
   integer :: ncodevel(nncodevel), ncodediffus(nncodediffus)
   integer :: ncodegen(nncodegen), ncodemech(nncodemech), ncodetim(nncodetim)
   integer :: ncodetimmeth(nncodetimmeth), ncodevar(nncodevar)
   integer :: ncodestop(nncodestop)
   integer :: nscodeupw(nncodeupw), nscodecsys(nncodecsys), &
              nscodecompr(nncodecompr), ncodetimbc(nncodetimbc)
   integer :: nscodevel(nncodevel), nscodediffus(nncodediffus)
   integer :: nscodegen(nncodegen), nscodemech(nncodemech)
   integer :: nscodeapply(nncodeapply), nscodetim(nncodetim)
   integer :: nscodetimmeth(nncodetimmeth), nscodevar(nncodevar)
   integer :: nscodetimbc(nncodetimbc), nscodestop(nncodestop)
   integer :: nscodeitmeth(nncodeitmeth), ncodeitmeth(nncodeitmeth)
   integer :: nscodeprec(nncodepreca), ncodeprec(nncodepreca)
   integer :: nscodebear(nncodebear), ncodebear(nncodebear)
   integer :: nscodelinear(nncodelinear), ncodelinear(nncodelinear)
   integer :: nscodelin(nncodelin), ncodelin(nncodelin)
   integer :: nscodereynolds(nncodereynolds), ncodereynolds(nncodereynolds)
   integer :: nscodereynoldsbn(nncodereynoldsbn), &
              ncodereynoldsbn(nncodereynoldsbn)
   integer :: nscodenatbnd(nncodenatbnd), ncodenatbnd(nncodenatbnd)
   integer :: nscodenavstoks(nncodenavstoks), ncodenavstoks(nncodenavstoks)
   integer :: nscodemodel(nncodemodel), ncodemodel(nncodemodel)
   integer :: nscodestress(nncodestress), ncodestress(nncodestress)
   integer :: nscodestressmod(nncodestressmod), ncodestressmod(nncodestressmod)
   integer :: nscodestressbn(nncodestressbn), ncodestressbn(nncodestressbn)
   integer :: nscodeprob(nncodeprob), ncodeprob(nncodeprob)
   integer :: nscoderenum(nncoderenum), ncoderenum(nncoderenum)

   character (len=14) :: codecont (nncodecont)
   character (len=13) :: codecsys (nncodecsys)
   character (len=14) :: codecompr (nncodecompr)
   character (len=9)  :: codediffus (nncodediffus)
   character (len=18) :: codeupw (nncodeupw)
   character (len=10) :: codevel (nncodevel)
   character (len=17) :: codegen (nncodegen)
   character (len=15) :: codemech (nncodemech)
   character (len=16) :: codeapply (nncodeapply)
   character (len=37) :: codetim (nncodetim)
   character (len=19) :: codetimmeth (nncodetimmeth)
   character (len=9)  :: codevar (nncodevar)
   character (len=13) :: codetimbc (nncodetimbc)
   character (len=6)  :: codestop(nncodestop)
   character (len=16) :: codeitmeth(nncodeitmeth)
   character (len=24) :: codeprec(nncodepreca)
   character (len=15) :: codebear(nncodebear)
   character (len=16) :: codelinear(nncodelinear)
   character (len=10) :: codelin(nncodelin)
   character (len=21) :: codereynolds(nncodereynolds)
   character (len=21) :: codereynoldsbn(nncodereynoldsbn)
   character (len=10) :: codenatbnd(nncodenatbnd)
   character (len=28) :: codenavstoks(nncodenavstoks)
   character (len=16) :: codemodel(nncodemodel)
   character (len=22) :: codestress(nncodestress)
   character (len=31) :: codestressmod(nncodestressmod)
   character (len=22) :: codestressbn(nncodestressbn)
   character (len=30) :: codeprob(nncodeprob)
   character (len=17) :: coderenum(nncoderenum)

!   code...       strings
!   codeapply     strings following keyword APPLY_UPWIND
!   codecompr     strings following keyword COMPRESSIBLE
!   codecsys      strings following keyword COORDINATE_SYSTEM
!   codediffus    strings with respect to the keyword DIFFUSION
!   codegen       some general strings
!   codeitmeth    string corresponding to iteration method
!   codemech      strings with respect to mechanical problems
!   codeprec      string corresponding to preconditioner
!   coderenum     string corresponding to renumbering
!   codetim       strings with respect to time integration
!   codetimmeth   substrings with respect to time integration (method)
!   codeupw       strings following keyword SUPG
!   codevel       strings with respect to the keyword VELOCITY
!   ncode...      the length of the strings
!   nncode...     the number of strings
!   nscode...     number of significant letters

!  Initialization

   data codeupw / 'NONE', 'CLASSIC', 'ILIN', 'DOUBLY_ASSYMPTOTIC', &
                  'CRITICAL', 'HUGHES', 'TIME_DEPENDENT', 'DC1', 'DC2', &
                  'MIZUKAMI_MAX', 'MIZUKAMI_ACT', 'MIZUKAMI_USE', &
                  'TORNBERG_TIME' /
   data ncodeupw / 4, 7, 4,18, 8,   6,14, 3, 3,12, &
                  12,12,13 /
   data nscodeupw / 3, 3, 4, 4, 4,  4, 4, 3, 3,12, &
                   12,12, 4/

!  codeupw       contains subkeywords
!                 1: NONE
!                 2: CLASSIC
!                 3: ILIN
!                 4: DOUBLY_ASSYMPTOTIC
!                 5: CRITICAL
!                 6: HUGHES
!                 7: TIME_DEPENDENT
!                 8: DC1
!                 9: DC2
!                10: MIZUKAMI_MAX
!                11: MIZUKAMI_ACT
!                12: MIZUKAMI_USE
!                13: TORNBERG_TIME

   data codecsys / 'CARTESIAN', 'AXI_SYMMETRIC', 'POLAR' /
   data ncodecsys / 9,13, 5 /
   data nscodecsys / 3, 3, 3 /

!  codecsys      contains subkeywords
!                 1: CARTESIAN
!                 2: AXI_SYMMETRIC
!                 3: POLAR

   data codenatbnd / 'TYPENATBND', 'DIFF_SIGMA', 'DIFF_FLUX' /
   data ncodenatbnd / 10,10, 9 /
   data nscodenatbnd / 7, 7, 7 /

!  codenatbnd      contains subkeywords for natural boundary conditions
!                 1: TYPENATBND
!                 2: DIFF_SIGMA
!                 3: DIFF_FLUX

   data codereynolds / 'TYPE_OF_BEARING', 'LINEARIZATION', &
                  'INTEGRATION_RULE', 'TRANSFORMATION', &
                  'LAYER_THICKNESS', 'VISCOSITY', 'SQUEEZE', &
                  'CONSTANT', &
                  'REFERENCE_PRESSURE', 'VELOCITY', 'U_VELOCITY', &
                  'V_VELOCITY', 'DENSITY', 'RT', 'FORCE', 'X_FORCE', &
                  'Y_FORCE', 'UPPER_FACE_VELOCITY', &
                  'X_UPPER_FACE_VELOCITY', 'Y_UPPER_FACE_VELOCITY' /
   data ncodereynolds  /15,13,16,14,15,  9, 7, 8,18, 8, &
                        10,10, 7, 2, 5,  7, 7,19,21,21 /
   data nscodereynolds / 4, 4, 4, 4, 4,  4, 4, 4, 4, 4, &
                         4, 4, 2, 4, 4,  4, 4, 4, 4, 4 /

!   codereynolds    contains keywords for Reynolds equation
!                1: TYPE_OF_BEARING
!                2: LINEARIZATION
!                3: INTEGRATION_RULE
!                4: TRANSFORMATION
!                5: LAYER_THICKNESS
!                6: VISCOSITY
!                7: SQUEEZE
!                8: CONSTANT
!                9: REFERENCE_PRESSURE
!               10: VELOCITY
!               11: U_VELOCITY
!               12: V_VELOCITY
!               13: DENSITY
!               14: RT
!               15: FORCE
!               16: X_FORCE
!               17: Y_FORCE
!               18: UPPER_FACE_VELOCITY
!               19: X_UPPER_FACE_VELOCITY
!               20: Y_UPPER_FACE_VELOCITY

   data codereynoldsbn / 'RESTRICTION', 'CAPILLARY_RESTRICTION', &
                         'OIL_SUPPLY_PRESSURE' /
   data ncodereynoldsbn /  11,21,19 /
   data nscodereynoldsbn /  3, 3, 3 /

!  codereynoldsbn      contains subkeywords for natural boundary conditions
!                 for reynold
!                1: RESTRICTION
!                2: CAPILLARY_RESTRICTION
!                3: OIL_SUPPLY_PRESSURE

   data codebear / 'INCOMPRESSIBLE', 'COMPRESSIBLE', 'MASS_CONSERVING' /
   data ncodebear / 14,12, 15 /
   data nscodebear / 5, 3, 3 /

!  codebear     contains subkeywords for type_bearing
!                 1: INCOMPRESSIBLE
!                 2: COMPRESSIBLE
!                 3: MASS_CONSERVING

   data codenavstoks / 'MODEL', 'INTEGRATION_RULE', &
                       'COORDINATE_SYSTEM', 'LINEARIZATION', &
                       'PENALTY', 'DENSITY', 'ANGULAR_VELOCITY', 'FORCE', &
                       'X_FORCE', 'Y_FORCE', 'Z_FORCE', 'VISCOSITY', &
                       'POWER_N', 'LAMBDA', 'VOLUME_EXPANSION_COEFFICIENT', &
                       'REF_TEMPERATURE', 'HEAT_CAPACITY', &
                       'THERMAL_CONDUCTIVITY', 'HEAT_SOURCE' /
   data ncodenavstoks / 5,16,17,13, 7,   7,16, 5, 7, 7, &
                        7, 9, 8, 6,28,  15,13,21,11 /
   data nscodenavstoks / 3, 3, 4, 3, 5,   4, 4, 3, 3, 3, &
                         3, 4, 5, 3, 3,   3, 6, 4, 6 /

!  codenavstoks      contains subkeywords for natural boundary conditions
!                 1: MODEL
!                 2: INTEGRATION_RULE
!                 3: COORDINATE_SYSTEM
!                 4: LINEARIZATION
!                 5: PENALTY
!                 6: DENSITY
!                 7: ANGULAR_VELOCITY
!                 8: FORCE
!                 9: X_FORCE
!                10: Y_FORCE
!                11: Z_FORCE
!                12: VISCOSITY
!                13: POWER_N
!                14: LAMBDA
!                15: VOLUME_EXPANSION_COEFFICIENT
!                16: REF_TEMPERATURE
!                17: HEAT_CAPACITY
!                18: THERMAL_CONDUCTIVITY
!                19: HEAT_SOURCE

   data codemodel / 'NEWTONIAN', 'POWER_LAW', 'CARREAU', &
                    'PLASTICO_VISCOUS', 'SPECIAL', 'DIAGONAL' /
   data nscodemodel / 3, 3, 3, 3, 4,    4 /
   data ncodemodel / 9, 9, 7,16, 7,   8  /

!  codemodel     contains subkeywords for model
!                 1: NEWTONIAN
!                 2: POWER_LAW
!                 3: CARREAU
!                 4: PLASTICO_VISCOUS
!                 5: SPECIAL
!                 6: DIAGONAL
   data codecont / 'INCOMPRESSIBLE', 'COMPRESSIBLE', 'GOERTLER', &
                   'PRESSURE', 'MASS_MATRIX' /
   data nscodecont  / 5, 4, 4, 4, 4 /
   data ncodecont   /14,12, 8, 8,11 /

!  codecont     contains subkeywords for continuity equation

   data codestress /  'ELASTIC_MODULUS', 'POISSONS_RATIO', 'THICKNESS', &
                  'STRESS_STRAIN_RELATION', 'INTEGRATION_RULE', 'FORCE', &
                  'X_FORCE', 'Y_FORCE', 'Z_FORCE', 'INITIAL_STRAIN', &
                  'XX_INITIAL_STRAIN', 'XY_INITIAL_STRAIN', &
                  'XZ_INITIAL_STRAIN', 'YY_INITIAL_STRAIN', &
                  'YZ_INITIAL_STRAIN', 'ZZ_INITIAL_STRAIN', &
                  'INITIAL_STRESS', &
                  'XX_INITIAL_STRESS', 'XY_INITIAL_STRESS', &
                  'XZ_INITIAL_STRESS', 'YY_INITIAL_STRESS', &
                  'YZ_INITIAL_STRESS', 'ZZ_INITIAL_STRESS', &
                  'DENSITY', 'E_X', 'E_Y', 'NU_X', 'NU_Y', &
                  'SHEAR_MODULUS', 'DMAT_11', 'DMAT_21', 'DMAT_31', &
                  'DMAT_22', 'DMAT_23', 'DMAT_33', 'DMAT_43', 'DMAT_44' /
   data nscodestress /   4, 4, 3, 5, 3,  3, 3, 3, 3,12, &
                        15,15,15,15,15, 15,12,15,15,15, &
                        15,15,15, 4, 3,  3, 4, 4, 4, 7, &
                         7, 7, 7, 7, 7,  7, 7 /
   data ncodestress / 15,14, 9,22,16,  5, 7, 7, 7,14, &
                      18,18,18,18,18, 18,14,18,18,18, &
                      18,18,18, 7, 3,  3, 4, 4,13, 7, &
                       7, 7, 7, 7, 7,  7, 7 /

!  codestress     contains subkeywords for stress strain element
!                1: ELASTIC_MODULUS
!                2: POISSONS_RATIO
!                3: THICKNESS
!                4: STRESS_STRAIN_RELATION
!                5: INTEGRATION_RULE
!                6: FORCE
!                7: X_FORCE
!                8: Y_FORCE
!                9: Z_FORCE
!               10: INITIAL_STRAIN
!               11: XX_INITIAL_STRAIN
!               12: XY_INITIAL_STRAIN
!               13: XZ_INITIAL_STRAIN
!               14: YY_INITIAL_STRAIN
!               15: YZ_INITIAL_STRAIN
!               16: ZZ_INITIAL_STRAIN
!               17: INITIAL_STRESS
!               18: XX_INITIAL_STRESS
!               19: XY_INITIAL_STRESS
!               20: XZ_INITIAL_STRESS
!               21: YY_INITIAL_STRESS
!               22: YZ_INITIAL_STRESS
!               23: ZZ_INITIAL_STRESS
!               24: DENSITY
!               25: E_X
!               26: E_X
!               27: NU_X
!               28: NU_Y
!               29: G_XY
!               30: DMAT_11
!               31: DMAT_21
!               32: DMAT_31
!               33: DMAT_22
!               34: DMAT_23
!               35: DMAT_33
!               36: DMAT_34
!               37: DMAT_44

   data codestressmod / 'PLANE_STRESS', 'PLANE_STRAIN', &
                   'AXI_SYMMETRIC_STRESS', 'ORTHOTROPIC_PLANE_STRESS', &
                   'ORTHOTROPIC_PLANE_STRAIN', &
                   'STRATIFIED_AXI_SYMMETRIC_STRESS', &
                   'USER_DEFINED_ELASTICITY_CART', &
                   'USER_DEFINED_ELASTICITY_AXI' /
   data nscodestressmod / 10,10, 3,22,22,  5,27,27 /
   data ncodestressmod / 12,12,20,24,24,  31,28,27  /

!  codestressmod     contains subkeywords for stress model
!                1: PLANE_STRESS
!                2: PLANE_STRAIN
!                3: AXI_SYMMTRIC_STRESS
!                4: ORTHOTROPIC_PLANE_STRESS
!                5: ORTHOTROPIC_PLANE_STRAIN
!                6: STRATIFIED_AXI_SYMMTRIC_STRESS
!                7: USER_DEFINED_ELASTICITY_CART
!                8: USER_DEFINED_ELASTICITY_AXI

   data codestressbn / 'X_LOAD', 'Y_LOAD', 'Z_LOAD', 'THICKNESS', &
                  'STRESS_STRAIN_RELATION', 'ILOAD', &
                  'INTEGRATION_RULE' /
   data nscodestressbn /  4, 4, 4, 3, 5,  3, 3 /
   data ncodestressbn /  6, 6, 6, 9,22,  5,16 /

!  codestressbn     contains subkeywords for boundary conditions for stress
!                   model
!                1: x_load
!                2: y_load
!                3: THICKNESS
!                4: Z_LOAD
!                5: STRESS_STRAIN_RELATION
!                6: ILOAD
!                7: INTEGRATION_RULE

   data codeprob / 'NATURAL_BOUNDARY_CONDITIONS', &
                   'ESSENTIAL_BOUNDARY_CONDITIONS', 'END', &
                   'LOCALTRANSFORM', 'UNKNOWNCONSTANT', 'RENUMBER', &
                   'PROBLEM', 'TYPES', 'BOUNDARY_ELEMENTS', &
                   'GLOBAL_UNKNOWNS', 'GLOBAL_ELEMENTS', &
                   'GLOBAL_RENUMBERING', 'PRINT_LEVEL', &
                   'FICTITIOUS_UNKNOWNS', 'FICTITIOUS_ELEMENTS', &
                   'SKIP_ELEMENTS', 'LEVELSET', 'NUM_LEVELSET', &
                   'REORDER', 'PERIODICAL_BOUNDARY_CONDITIONS', &
                   'NEWSTYLE', 'OLDSTYLE' /
   data nscodeprob /  3,  3,  3,  4,  4,    4,  4,  5,  4,  9, &
                      9,  9,  5, 14, 14,    9,  5,  7,  4,  5, &
                      5,  5 /
   data ncodeprob / 27, 29,  3, 14, 15,    8,  7,  5, 17, 15, &
                    15, 18, 11, 19, 19,   13,  8, 12,  7, 30, &
                     8,  8 /

!  codeprob     contains subkeywords for problem
!                1   NATURAL_BOUNDARY_CONDITIONS
!                2   ESSENTIAL_BOUNDARY_CONDITIONS
!                3   END
!                4   LOCALTRANSFORM
!                5   UNKNOWNCONSTANT
!                6   RENUMBER
!                7   PROBLEM
!                8   TYPES
!                9   BOUNDARY_ELEMENTS
!               10   GLOBAL_UNKNOWNS
!               11   GLOBAL_ELEMENTS
!               12   GLOBAL_RENUMBERING
!               13   PRINT_LEVEL
!               14   FICTITIOUS_UNKNOWNS
!               15   FICTITIOUS_ELEMENTS
!               16   SKIP_ELEMENTS
!               17   LEVELSET
!               18   NUM_LEVELSET
!               19   REORDER
!               20   PERIODICAL_BOUNDARY_CONDITIONS
!               21   NEWSTYLE                         (temporary)
!               22   OLDSTYLE                         (temporary)

   data coderenum / 'NOT', 'CUTHILL_MCKEE', 'SLOAN', 'NESTED_DISSECTION' /
   data nscoderenum /  3, 3, 3, 3 /
   data ncoderenum  /  3,13, 5,17 /

!  coderenum     contains subkeywords for renumbering
!                1: not
!                2: CUTHILL_MCKEE
!                3: SLOAN
!                4: NESTED_DISSECTION

   data codelinear / 'NONE', 'PICARD', 'NEWTON', 'INCORRECT_PICARD' /
   data ncodelinear / 4, 6, 6, 16 /
   data nscodelinear / 3, 3, 3, 3 /

!  codelinear     contains subkeywords for linearization
!                 1: INCOMPRESSIBLE
!                 2: COMPRESSIBLE

   data codelin / 'LINEAR',  'NON_LINEAR' /
   data ncodelin  / 6,10 /
   data nscodelin / 3, 3 /

!  codelin     contains subkeywords for linearization
!                1: LINEAR
!                2: NON_LINEAR

   data codecompr / 'INCOMPRESSIBLE', 'COMPRESSIBLE', 'ABSOLUTE', 'NON_LINEAR' /
   data ncodecompr / 14,12, 8,10 /
   data nscodecompr / 7, 5, 3, 3 /

!  codecompr     contains subkeywords
!                 1: INCOMPRESSIBLE
!                 2: COMPRESSIBLE
!                 3: ABSOLUTE
!                 4: NON_LINEAR

   data codediffus / 'DIFFUSION', 'DIFF_X', 'DIFF_Y', 'DIFF_Z', 'DIFF_XX',&
                     'DIFF_XY', 'DIFF_XZ', 'DIFF_YY', 'DIFF_YZ', 'DIFF_XZ' /
   data ncodediffus / 9, 6, 6, 6, 7,   7, 7, 7, 7, 7 /
   data nscodediffus  / 6, 6, 6, 6, 7,   7, 7, 7, 7, 7 /

!  codediffus    contains keywords recognized for coefficients type 702
!                 1: DIFFUSION
!                 2: DIFF_X
!                 3: DIFF_Y
!                 4: DIFF_Z
!                 5: DIFF_XX
!                 6: DIFF_XY
!                 7: DIFF_XZ
!                 8: DIFF_YY
!                 9: DIFF_YZ
!                10: DIFF_ZZ

   data codevel / 'VELOCITY', 'U_VELOCITY', 'V_VELOCITY', 'W_VELOCITY' /
   data ncodevel / 8,10,10,10 /
   data nscodevel / 5, 7, 7, 7 /

!  codevel      contains keywords for velocity
!                1: VELOCITY
!                2: U_VELOCITY
!                3: V_VELOCITY
!                4: W_VELOCITY

   data codemech / 'ELASTIC_MODULUS', 'SECOND_MOMENT', 'LOAD' /
   data ncodemech  /15,13, 4 /
   data nscodemech / 4, 4, 3 /

!  codemech      contains keywords for mechanical problems
!                1: ELASTIC_MODULUS
!                2: SECOND_MOMENT
!                3: LOAD

   data codeapply / 'ALL', 'EXCL_MASS_MATRIX', 'CONVECTION_ONLY' /
   data ncodeapply  / 3,16,15 /
   data nscodeapply / 3, 3, 3 /

!  codeapply      contains subkeywords
!                 1: ALL
!                 2: EXCL_MASS_MATRIX
!                 3: CONVECTION_ONLY

   data codegen / 'SOURCE', 'INTEGRATION_RULE', 'COORDINATE_SYSTEM', &
                  'SUPG', 'DENSITY', 'TYPE_CONVECTION', 'ZERO_ORDER_COEF', &
                  'HEAT_CAPACITY', 'APPLY_UPWIND', 'LINEARIZATION' /
   data ncodegen  / 6,16,17, 4, 7,  15,15,13,12,13 /
   data nscodegen / 4, 3, 4, 4, 4,   8, 4, 4, 5, 4 /

!  codegen      contains subkeywords
!                1: SOURCE
!                2: INTEGRATION_RULE
!                3: COORDINATE_SYSTEM
!                4: SUPG
!                5: DENSITY
!                6: TYPE_CONVECTION
!                7: ZERO_ORDER_COEF
!                8: HEAT_CAPACITY
!                9: APPLY_UPWIND
!               10: LINEARIZATION

   data codetim  / 'METHOD', 'TINIT', 'TEND', 'THETA', 'TSTEP', &
                   'TOUTINIT', 'TOUTEND', 'TOUTSTEP', &
                   'ABS_STATIONARY_ACCURACY', 'REL_STATIONARY_ACCURACY', &
                   'MASS_MATRIX',       'STIFFNESS_MATRIX', &
                   'RIGHT_HAND_SIDE',   'SEQ_SOLUTION_METH', &
                   'SEQ_COEFFICIENTS',  'SEQ_BOUNDARY_CONDITIONS', &
                   'NUMBER_OF_COUPLED_EQUATIONS', 'BOUNDARY_CONDITIONS', &
                   'LINEAR_SUBELEMENT', 'DIAGONAL_MASS_MATRIX', &
                   'CONSISTENT_MASS_MATRIX', 'SEQ_OUTPUT', 'ACCURACY', &
                   'PRINT_LEVEL', 'THRESHOLD_TIME', 'AT_ERROR', &
                   'USE_CTIMEN', 'KEEP_T', 'PRINT_TIME_HISTORY', &
                   'NON_LINEAR_ITERATION', 'ABS_ITERATION_ACCURACY', &
                   'REL_ITERATION_ACCURACY', 'MAX_ITER', &
                   'NO_COMPUTATION', 'REUSE_TIME_PARAMETERS', &
                   'BETA', 'GAMMA', 'ALPHA_F','ALPHA_M', &
                   'UPDATED_LAGRANGE', 'SKIP_MESH_DEFORMATION', &
                   'MIN_ITER', 'SEQ_ADD_RHSD', 'REACTION_FORCE' /
   data ncodetim  / 6,   5,  4,  5,  5,   8,  7,  8, 23, 23, &
                    11, 16, 15, 19, 16,  23, 27, 19, 17, 20, &
                    22, 10,  8, 11, 14,   8, 10,  6, 18, 20, &
                    22, 22,  8, 14, 21,   4,  5,  7,  7, 37, &
                    21,  8, 12, 14 /
   data nscodetim /  6,  5,  4,  5,  5,   5,  5,  5,  7,  7, &
                     4,  4,  4,  7,  7,   7,  4,  4, 10, 10, &
                    10,  7,  3,  8,  5,   5,  6,  6,  9,  7, &
                     7,  7,  6,  7,  9,   4,  4,  7,  7,  7, &
                     8,  6,  6,  5 /

!  codetim      contains keywords for time integration
!                1:  METHOD
!                2:  TINIT
!                3:  TEND
!                4:  THETA
!                5:  TSTEP
!                6:  TOUTINIT
!                7:  TOUTEND
!                8:  TOUTSTEP
!                9:  ABS_STATIONARY_ACCURACY
!               10:  REL_STATIONARY_ACCURACY
!               11:  MASS_MATRIX
!               12:  STIFFNESS_MATRIX
!               13:  RIGHT_HAND_SIDE
!               14:  SEQ_SOLUTION_METHOD
!               15:  SEQ_COEFFICIENTS
!               16:  SEQ_BOUNDARY_CONDITIONS
!               17:  NUMBER_OF_COUPLED_EQUATIONS
!               18:  BOUNDARY_CONDITIONS
!               19:  LINEAR_SUBELEMENT
!               20:  DIAGONAL_MASS_MATRIX
!               21:  CONSISTENT_MASS_MATRIX
!               22:  SEQ_OUTPUT
!               23:  ACCURACY
!               24:  PRINT_LEVEL
!               25:  THRESHOLD_TIME
!               26:  AT_ERROR
!               27:  USE_CTIMEN
!               28:  KEEP_T
!               29:  PRINT_TIME_HISTORY
!               30:  NON_LINEAR_ITERATION
!               31:  ABS_ITERATION_ACCURACY
!               32:  REL_ITERATION_ACCURACY
!               33:  MAX_ITER
!               34:  NO_COMPUTATION
!               35:  REUSE_TIME_PARAMETERS
!               36:  BETA
!               37:  GAMMA
!               38:  ALPHA_F
!               39:  ALPHA_M
!               40:  UPDATED_LAGRANGE
!               41:  SKIP_MESH_DEFORMATION
!               42:  MIN_ITER
!               43:  SEQ_ADD_RHSD
!               44:  REACTION_FORCE

   data codetimmeth / 'STATIONARY', &
                      'EULER_TRAPEZOID', 'ROZENBROCK_WANNER', &
                      'RUNGE_KUTTA_12', 'RUNGE_KUTTA_34', 'EULER_IMPLICIT', &
                      'CRANK_NICOLSON', 'EULER_EXPLICIT', 'RUNGE_KUTTA_4', &
                      'THETA', 'FRACTIONAL_STEP', 'CENTRAL_DIFFERENCES', &
                      'GENERALIZED_THETA', 'SECOND_ORDER_GEAR', &
                      'NEWMARK', 'GENERALIZED_ALPHA' /
   data ncodetimmeth   /10,15,17,14,14,  14,14,14,13, 5, &
                        15,19,17,17, 7,  17 /
   data nscodetimmeth  / 4,10, 6,14,14,   9, 5, 9,13, 5, &
                         4, 7,15,10, 6,  14 /

!  codetimmeth  contains subkeywords for keyword method in time integration
!                1:  STATIONARY
!                2:  EULER_TRAPEZOID
!                3:  ROZENBROCK_WANNER
!                4:  RUNGE_KUTTA_12
!                5:  RUNGE_KUTTA_34
!                6:  EULER_IMPLICIT
!                7:  CRANK_NICOLSON
!                8:  EULER_EXPLICIT
!                9:  RUNGE_KUTTA_4
!               10:  THETA
!               11:  FRACTIONAL_STEP
!               12:  CENTRAL_DIFFERENCES
!               13:  GENERALIZED_THETA
!               14:  SECOND_ORDER_GEAR
!               15:  NEWMARK
!               16:  GENERALIZED_ALPHA

   data codetimbc / 'VARIABLE', 'CONSTANT', 'INITIAL_FIELD', 'OLD_VECTOR' /
   data ncodetimbc  / 9, 8,13,10 /
   data nscodetimbc / 3, 4, 4, 7 /

!  codetimbc      contains subkeywords
!                 1: VARIABLE
!                 2: CONSTANT
!                 3: INITIAL_FIELD
!                 4: OLD_VECTOR

   data codevar / 'VARIABLE', 'CONSTANT', 'ZERO' /
   data ncodevar  / 9, 8, 4 /
   data nscodevar / 3, 4, 4 /

!  codevar      contains subkeywords
!                 1: VARIABLE
!                 2: CONSTANT
!                 3: ZERO

   data codestop   / 'STOP', 'RETURN', 'RESUME' /
   data ncodestop  / 4, 6, 6 /
   data nscodestop / 3, 2, 2 /

!  codestop      contains subkeywords
!                 1: STOP
!                 2: RETURN
!                 3: RESUME

   data codeitmeth   / 'CGS', 'GMRESR', 'GMRES', 'CG', &
                       'OVERRELAXATION', 'BICGSTAB', 'GCR', 'SIMPLE_GCR', &
                       'SYMMLQ', 'SIMPLER_GCR', 'ML_MULTIGRID', 'IDR', &
                       'AL_GCR', 'HSIMPLER_GCR', 'MSIMPLER_GCR', &
                       'LSC_GCR', 'QLSC_GCR', 'SCHUR', 'BLOCK_TRIANGULAR', &
                       'RICHARDSON', 'CHEBYSHEV', 'FGMRES', 'DGMRES', &
                       'BICG', 'TFQMR', 'TCQMR', 'CR', 'LSQR', 'PREONLY', &
                       'DEFAULT' /
   data ncodeitmeth  /  3, 6, 5, 2,14,    8, 3, 10, 6,11, &
                       12, 3, 6,12,12,    7, 8,  5,16,10, &
                        9, 6, 6, 4, 5,    5, 5,  4, 7, 7 /
   data nscodeitmeth /  3, 6, 5, 2, 4,    8, 3, 10, 6,11, &
                        7, 3, 4, 4, 4,    3, 4,  5, 5, 4, &
                        5, 4, 4, 4, 4,    4, 2,  4, 4, 3 /

!  codeitmeth    contains subkeywords
!                 1:  cgs
!                 2:  gmresr
!                 3:  gmres
!                 4:  cg
!                 5:  overrelaxation
!                 6:  bicgstab
!                 7:  gcr
!                 8:  simple_gcr
!                 9:  symmlq
!                10:  simpler_gcr
!                11:  ml_multigrid
!                12:  idr
!                13:  al_gcr
!                14:  hsimpler_gcr
!                15:  msimpler_gcr
!                16:  lsc_gcr
!                17:  qlsc_gcr
!                18:  schur
!                19:  block_triangular
!                20:  richardson
!                21:  chebyshev
!                22:  fgmres
!                23:  dgmres
!                24:  bicg
!                25:  tfqmr
!                26:  tcqmr
!                27:  cr
!                28:  lsqr
!                29:  preonly
!                30:  default
   data codeprec / 'NONE', 'DIAGONAL', 'EISENSTAT', 'ILU', &
                   'GAUSS_SEIDEL', 'MOD_EISENSTAT', 'OLD', &
                   'BLOCK_GAUSS_SEIDEL', 'BLOCK_EISENSTAT', &
                   'BLOCK_ILU', 'JACOBI', 'BJACOBI', 'SOR', 'ICC', &
                   'ASM', 'AMG', 'MUMPS', 'ML', 'HYPRE', 'ZERO', &
                   'OLD_SOLUTION', 'RANDOM', 'REL_SOLUTION', &
                   'REL_RESIDUAL', 'ABSOLUTE', 'REL_RIGHT', &
                   'STOP', 'RESUME', 'NONE','APPROXIMATE_EIGENVECTORS', &
                   'DESTROY', 'KEEP', 'OLD', 'NONE', 'ROW', 'SYMMETRIC', &
                   'COLUMN', 'DEFLATION', 'COARSE_GRID_CORRECTION', &
                   'NONE', 'DEFLATION', 'COARSE_GRID_CORRECTION', &
                   'APPROXIMATE_EIGENVECTORS', 'ALGEBRAIC', 'NONE', &
                   'DIAGONAL', 'LOCAL', 'GLOBAL', 'BLOCK_JACOBI', &
                   'GCR' /
   data nscodeprec / 2, 4, 3, 3, 4,    3, 3, 8, 8, 8, &
                     6, 7, 3, 3, 3,    3, 5, 2, 5, &
                     4, 3, 4, 7, 7,    7, 3, 4, 5, 4, &
                     5, 5, 4, 3, 4,    3, 5, 5, 5, 5, &
                     4, 5, 5, 5, 5,    2, 4, 3, 3, 5, &
                     3 /
   data ncodeprec  / 4, 8, 9, 3,12,   13, 3,18,15, 9, &
                     6, 7, 3, 3, 3,    3, 5, 2, 5, 4, &
                    12, 6,12,12, 8,   18, 4, 6, 4,24, &
                     7, 4, 3, 4, 3,    9, 6, 9,22, 4, &
                     9,22,24, 9, 4,    8, 5, 6,12, 3 /

!  codeprec   table with the keywords after preconditioning,
!             termination_criterion or start
!             Values:
!             1:  none
!             2:  diagonal
!             3:  eisenstat
!             4:  ilu
!             5:  gauss_seidel
!             6:  mod_eisenstat
!             7:  old
!             8:  block_gauss_seidel
!             9:  block_eisenstat
!            10:  block_ilu
!            11:  jacobi
!            12:  bjacobi
!            13:  sor
!            14:  icc
!            15:  asm
!            16:  amg
!            17:  mumps
!            18:  ml
!            19:  hypre
!            20:  zero
!            21:  old_solution
!            22:  random
!            23:  rel_solution
!            24:  rel_residual
!            25:  absolute
!            26:  rel_right_hand_side
!            27:  stop
!            28:  resume
!            29:  none
!            30:  approximate_eigenvectors
!            31:  destroy
!            32:  keep
!            33:  old
!            34:  none
!            35:  row
!            36:  symmetric
!            37:  column
!            38:  deflation
!            39:  coarse_grid_correction
!            40:  none
!            41:  deflation
!            42:  coarse_grid_correction
!            43:  approximate_eigenvectors
!            44:  algebraic
!            45:  none
!            46:  diagonal
!            47:  local
!            48:  global
!            49:  block_jacobi
!            50:  gcr

end module sepmodulestrings
