      subroutine priinelgrps ( iinput, iinp, nelgrp )
! ======================================================================
!
!        programmer    Guus Segal
!        version  1.0  date 15-08-1999
!
!   copyright (c) 1999-1999  "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
! **********************************************************************
!
!                       DESCRIPTION
!
!
!
! **********************************************************************
!
!                       KEYWORDS
!
! **********************************************************************
!
!                       MODULES USED
!
      implicit none
! **********************************************************************
!
!                       COMMON BLOCKS
!
      include 'SPcommon/cmcdpif90'

! **********************************************************************
!
!                       INPUT / OUTPUT PARAMETERS
!
      integer iinput(*), iinp, nelgrp
! **********************************************************************
!
!                       LOCAL PARAMETERS
!
      integer i, nlines, nsurel, nvolel, j
! **********************************************************************
!
!                       SUBROUTINES CALLED
!
! **********************************************************************
!
!                       I/O
!
! **********************************************************************
!
!                       ERROR MESSAGES
!
! **********************************************************************
!
!                       PSEUDO CODE
!
! **********************************************************************
!
!                       DATA STATEMENTS
!
! ======================================================================
!
      nlines = iinput(6)
      nelgrp = 0
      if ( nlines.gt.0 ) then
         write(irefwr,100)
100      format(' Information of line elements' )
         do i = 1, nlines
            write(irefwr,110) i, (iinput(j), j=iinp,iinp+3)
            nelgrp = max(nelgrp,iinput(iinp))
110         format(i4,':  ', 10i6)
            iinp = iinp+4
         end do
      end if
      nsurel = iinput(7)
      if ( nsurel.gt.0 ) then
         write(irefwr,120)
120      format(' Information of surface elements' )
         do i = 1, nsurel
            write(irefwr,110) i, (iinput(j), j=iinp,iinp+3)
            nelgrp = max(nelgrp,iinput(iinp))
            iinp = iinp+4
         end do
      end if
      nvolel = iinput(8)
      if ( nvolel.gt.0 ) then
         write(irefwr,130)
130      format(' Information of volume elements' )
         do i = 1, nvolel
            write(irefwr,110) i, (iinput(j), j=iinp,iinp+3)
            nelgrp = max(nelgrp,iinput(iinp))
            iinp = iinp+4
         end do
      end if
      end
