      subroutine priinvolumes ( iinput, iinp )
! ======================================================================
!
!        programmer    Guus Segal
!        version  1.0  date 15-08-1999
!
!   copyright (c) 1999-1999  "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
! **********************************************************************
!
!                       DESCRIPTION
!
!
!
! **********************************************************************
!
!                       KEYWORDS
!
! **********************************************************************
!
!                       MODULES USED
!
      implicit none
! **********************************************************************
!
!                       COMMON BLOCKS
!
      include 'SPcommon/cmcdpif90'

! **********************************************************************
!
!                       INPUT / OUTPUT PARAMETERS
!
      integer iinput(*), iinp
! **********************************************************************
!
!                       LOCAL PARAMETERS
!
      integer i, nvolms, ivolnr, ivolm, ifirst, ih
! **********************************************************************
!
!                       SUBROUTINES CALLED
!
! **********************************************************************
!
!                       I/O
!
! **********************************************************************
!
!                       ERROR MESSAGES
!
! **********************************************************************
!
!                       PSEUDO CODE
!
! **********************************************************************
!
!                       DATA STATEMENTS
!
! ======================================================================
!
      nvolms = iinput(5)
      write(irefwr,100)
100   format(' Information of volumes: iinput' )
      do ivolnr = 1, nvolms
         ifirst = iinp
         ivolm = iinput(iinp)
         call msh050 ( iinput, iinp, ivolm )
         ih = min(ifirst+9,iinp-1)
         write(irefwr,110) ivolnr, (iinput(i), i=ifirst,ih)
110      format(i4,':  ', 10i6)
         if ( iinp-ifirst.gt.10 ) then
            write(irefwr,120) (iinput(i), i=ih+1,iinp-1)
120         format(7x, 10i6)
         end if
      end do
      end
