      subroutine prinin1red ( iarray, n, m )
! ======================================================================
!
!        programmer    Guus Segal
!        version  1.0  date 02-04-2002
!
!   copyright (c) 2002-2002  "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
! **********************************************************************
!
!                       DESCRIPTION
!
!   Auxiliary help subroutine only meant for debugging purposes
!   The task of prinin is to print an integer array in the
!    form    m numbers new line m numbers, new line
! **********************************************************************
!
!                       KEYWORDS
!
!     print
! **********************************************************************
!
!                       MODULES USED
!
      use sepmodulecomio
      implicit none
! **********************************************************************
!
!                       COMMON BLOCKS
!
! **********************************************************************
!
!                       INPUT / OUTPUT PARAMETERS
!
      integer n, m, iarray(m,n)

!    iarray   i  integer array to be printed
!    m        i  Number of entries of the integer array to be printed per line
!    n        i  Number of lines of the integer array to be printed
! **********************************************************************
!
!                       LOCAL PARAMETERS
!
      integer i, j

!    i          General loop variable
!    j          General loop variable
! **********************************************************************
!
!                       SUBROUTINES CALLED
!
! **********************************************************************
!
!                       I/O
!
! **********************************************************************
!
!                       ERROR MESSAGES
!
! **********************************************************************
!
!                       PSEUDO CODE
!
! **********************************************************************
!
!                       DATA STATEMENTS
!
! ======================================================================
!
      do i = 1, n
         write(irefwr,110) (iarray(j,i),j=1,min(m,10))
110      format(10i10)
         if ( m.gt.10 ) &
            write(irefwr,120) (iarray(j,i),j=11,m)
120         format(10i10)
      end do

      end
