      subroutine creatn ( iincrt, kmeshlc, kproblc, isol )
      use sepmodulemain
      implicit none
      integer iincrt(*)
      integer, target :: isol(5,*), kmeshlc, kproblc
      integer iread, iseqnr, isubr, ictime
      double precision :: timebefore(2)
      call eropen ( 'creatn' )
      debug = .false.
      if ( debug ) then

!     --- Debug information

         write(irefwr,*) 'Debug information from creatn'
         call prinin ( iincrt, iincrt(1), 'iincrt' )
  1      format ( a, 1x, (10i6) )

      end if  ! ( debug )
      if ( ierror/=0 ) go to 1000

      kmesh2d(1) = kmeshlc
      kmesh => kmesh2d(1)
      kprob2d(1) = kproblc
      kprob => kprob2d(1)

      if ( itime>0 ) call ersettime ( timebefore )
      iread  = 0
      iseqnr = 1
      isubr  = 3
      ictime = 0
      if ( iincrt(1)>=2 ) iread  = iincrt(2)
      if ( iincrt(1)>=3 ) iseqnr = iincrt(3)
      if ( iincrt(1)>=4 ) isubr  = 5+100*(iincrt(4)-1)
      if ( iincrt(1)>=5 ) isubr  = iincrt(5)+100*(iincrt(4)-1)
      if ( iread==1 ) then
         isubr  = 1
         ictime = 0
      else if ( iread/=0 ) then
         isubr  = 1
         ictime = 1
      end if

      if ( debug ) &
         write(irefwr,1) 'isubr, ictime, iread, iseqnr', &
                          isubr, ictime, iread, iseqnr

      call er0034 ( isubr, ictime, isol, iseqnr, isol, 100 )

      if ( iincrt(1)>=4 ) iincrt(4) = isubr

1000  if ( debug ) then

!     --- Debug information

         write(irefwr,*) 'End creatn'

      end if  ! ( debug )
      call erclmn ( 'creatn', timebefore )

      end subroutine creatn
