      subroutine matstruc ( iincommt, kmeshlc, kproblc, intmatlc )
      use sepmodulemain
      use sepmodulekprob
      use sepmodulekmesh
      use sepmoduleintmat
      implicit none
      integer iincommt(*), kmeshlc, kproblc
      integer, target :: intmatlc
      integer lniincommat
      parameter ( lniincommat=25 )
      integer iincop(lniincommat), ielgrp, &
              iprint, fillin, iphys, i
      logical linear
      call eropen ( 'matstruc' )

      intmat => intmatlc
      kprob2d(1) = kproblc
      kmesh2d(1) = kmeshlc
      kmesh => kmesh2d(1)
      kprob => kprob2d(1)

      call sepfillkmesh(kmesh)


!     --- Copy array iincop from iincommt and extend with defaults

      do ielgrp = 1, nelgrp
         ishape = sepgetshape ( ielgrp )
         if ( ishape==9 .or. ishape==17 ) linear = .true.
      end do
      iincop = 0
      iincop(2) = 2
      iincop(5) = 1
      iincop(7) = ndim+1
      if ( linear ) then
         iincop(8) = ndim+1
      else
         iincop(8) = 2*ndim+1
      end if
      do i = 1, min(iincommt(1),6 )
         iincop(i) = iincommt(i)
      end do
      do i = 7, iincommt(1)
         if ( iincommt(i)>0 ) iincop(i) = iincommt(i)
      end do  ! i = 7, iincommt(1)

!     --- check iincop

      iprint = iincop(3)
      if ( iprint<0 .or. iprint>3 .and. iprint<10 .or. &
           iprint>13 ) then
         call errint ( 3, 1 )
         call errint ( iprint, 2 )
         call errchr ( 'iprint', 1 )
         call errsub ( 1630, 2, 0, 1 )
      end if
      iprob = iincop(5)
      if ( iprob<1 .or. iprob>nprob ) then
         call errint ( 5, 1 )
         call errint ( iprob, 2 )
         call errchr ( 'iprob', 1 )
         call errsub ( 1630, 2, 0, 1 )
      end if
      fillin = iincop(6)
      if ( fillin<0 .or. fillin>7 ) then
         call errint ( 6, 1 )
         call errint ( fillin, 2 )
         call errchr ( 'fillin_extra', 1 )
         call errsub ( 1630, 2, 0, 1 )
      end if
      iphys = iincop(7)
      if ( iphys<0 ) then
         call errint ( 7, 1 )
         call errint ( iphys, 2 )
         call errchr ( 'iphys1', 1 )
         call errsub ( 1630, 2, 0, 1 )
      end if
      iphys = iincop(8)
      if ( iphys<iincop(7) ) then
         call errint ( 8, 1 )
         call errint ( iphys, 2 )
         call errchr ( 'iphys2', 1 )
         call errsub ( 1630, 2, 0, 1 )
      end if
      if ( ierror/=0 ) go to 1000

!     --- Actual call

      call sepcommat ( iincop )

1000  call erclos ( 'matstruc' )

      end
