      subroutine overcs ( ichois, matr, irhsdlc, isol, intmatlc, kmeshlc, &
                          kproblc, eps, nmaxlc, iwork, work )
      use sepmodulematr
      use sepmodulemain
      use sepmoduleintmat
      use sepmodulesolve
      use sepmodulecons
      implicit none
      integer matr, irhsdlc(*), isol(*), kproblc, kmeshlc, &
              iwork(*), ichois, nmaxlc
      integer, target :: intmatlc(*)
      double precision work(*), eps
      call eropen ( 'overcs' )

      kprob2d(1) = kproblc
      kprob => kprob2d(1)
      kmesh2d(1) = kmeshlc
      kmesh => kmesh2d(1)
      call sepfillkmesh(kmesh)

      intmat => intmatlc(1)
      iseqsol = 1
      iseqsolut = 1
      iseqintmat = 1
      iseqreac = 0
      call sepinitinpsol  ! initialize inpsol/rinsol
      inpsol(1,1) = 19              ! size
      inpsol(3,1) = 5               ! overrl/cs
      inpsol(5,1) = nmaxlc          ! maximum number of iterations
      inpsol(6,1) = ichois/10       ! iprint
      inpsol(9,1) = mod(ichois,10)  ! istart
      inpsol(17,1) = iwork(2)       ! iconstrain
      inpsol(18,1) = iwork(3)       ! constraint a
      inpsol(19,1) = iwork(4)       ! constraint b
      rinsol(1,1) = eps
      rinsol(7,1) = work(1)
      rinsol(8,1) = work(2)
      iseqmt = matr
      call sepupdinpsol  ! Update inpsol for special situations
      call seplinsolkprob ( irhsdlc )
      call seplinsol ( matr, isol, irhsdlc )

      call erclos ( 'overcs' )
      end subroutine overcs
