      subroutine presbc ( kmeshlc, kproblc, isol, iinprs )
      use sepmodulemain
      implicit none
      integer :: iinprs(*)
      integer, target :: isol(5,*), kmeshlc, kproblc
      integer iread, iseqnr, isubr, ictime, ivectr
      integer inivectr
      call eropen ( 'presbc' )
      debug = .false. .and. ioutp>=0
      if ( debug ) then

!     --- Debug information

         write(irefwr,*) 'Debug information from presbc'
         call prinin ( iinprs, iinprs(1), 'iinprs' )
  1      format ( a, 1x, (10i6) )

      end if  ! ( debug )
      if ( ierror/=0 ) go to 1000

      kmesh2d(1) = kmeshlc
      kmesh => kmesh2d(1)
      kprob => kproblc

      iread  = 0
      iseqnr = 1
      isubr = 4
      ictime = 0

      if ( iinprs(1)>=4 ) then

!     --- iinprs(1)>=4, hence ivectr is stored in iinprs(4)

         ivectr = inivectr(iinprs(4))
         if ( debug ) write(irefwr,1) 'ivectr', ivectr

      end if  ! ( iinprs(1)>=4 )

      if ( iinprs(1)>=2 ) iread  = iinprs(2)
      if ( iinprs(1)>=3 ) iseqnr = iinprs(3)
      if ( iinprs(1)>=4 ) isubr  = 6+100*(ivectr-1)
      if ( iinprs(1)>=5 ) isubr  = iinprs(5)+100*(ivectr-1)

      if ( iread==1 ) then
         isubr  = -2
         ictime = 0
      else if ( iread/=0 ) then
         isubr  = -2
         ictime = 1
      end if

      if ( debug ) &
         write(irefwr,1) 'iread, iseqnr, isubr', iread, iseqnr, isubr

      call er0034 ( isubr, ictime, isol, iseqnr, isol, 100 )
      if ( iinprs(1)>=4 ) iinprs(4) = isubr

1000  call erclos ( 'presbc' )
      if ( debug ) then

!     --- Debug information

         write(irefwr,1) 'isubr', isubr
         write(irefwr,*) 'End presbc'

      end if  ! ( debug )

      end
