
/*********************************************************************
 *  made by : Kees Lemmens
 *  version : 0.1
 *  date    : May 1999
 *
 *  class name  : Vertex
 *  function    : contains a floating point coordinate (as opposed to 
 *                the Java integer coordinate Point)
 *
 *********************************************************************/

import java.io.Serializable;

final class Vertex
implements Serializable
{
   public float x;
   public float y;
   // public float z;

   public Vertex() // constructor
   {
      super();
   }
   
   public Vertex(double x,double y) // constructor
   {
      this.x = (float)x;
      this.y = (float)y;
   }

   public String toString()
   {
      return "(" + x + "," + y + ")";
   }
}
