      subroutine printintegerarray ( iarray, n, text )
! ======================================================================
!
!        programmer   Guus Segal
!        version 1.0  date   31-08-1999
!
!
!   copyright (c) 1999-1999 "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
!
!
! **********************************************************************
!
!                       DESCRIPTION
!
!     Auxiliary help subroutine only meant for debugging purposes
!     The task of prinin is to print an integer array in the
!     form   seq. number:  number etc.
! **********************************************************************
!
!                       KEYWORDS
!
!    print
! **********************************************************************
!
!                       MODULES USED
!
! **********************************************************************
!
!                       INPUT / OUTPUT PARAMETERS
!
      implicit none
      integer iarray(*), n
      character *(*) text

!    iarray   i  integer array to be printed
!    n        i  Number of entries of the integer array to be printed
!    text     i  Text to be printed in the heading
! **********************************************************************
!
!                       COMMON BLOCKS
!
      include 'SPcommon/cmcdpif90'

! **********************************************************************
!
!                       LOCAL PARAMETERS
!
      integer i

!    i          General loop variable
! **********************************************************************
!
!                       SUBROUTINES CALLED
!
! **********************************************************************
!
!                       I/O
!
! **********************************************************************
!
!                       ERROR MESSAGES
!
! **********************************************************************
!
!                       PSEUDO CODE
!
! **********************************************************************
!
!                       DATA STATEMENTS
!
! ======================================================================
!
      write ( irefwr, 100 ) text, (i,iarray(i),i=1,n)
100   format(1x,a/(5(i7,':',i7)))

      end
