      subroutine erwarn(name,iernr,iform,i1,i2,i3)
! ====================================================================== &
!
!        programmer     Guus Segal
!        version 7.4    date 19-01-1999 include commons
!        version 7.3    date 27-06-1992 Minor change in call to er0057
!        version 7.2    date 12-02-1992 Introduction of mxwarn
!        version 7.1    date 03-06-1988
!
!
!
!   copyright (c) 1985-1999  "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
! **********************************************************************
!
!                       DESCRIPTION
!
!   Print warnings
!
! **********************************************************************
!
!                       KEYWORDS
!
!    error_manipulation
! **********************************************************************
!
!                       MODULES USED
!
      use sepmodulecomio
      implicit none
! **********************************************************************
!
!                       INPUT / OUTPUT PARAMETERS
!
      character * (*) name
      integer i1, i2, i3, iernr, iform

!     i1         i    Extra  information
!     i2         i    Extra  information
!     i3         i    Extra  information
!     iernr      i    Error number
!     iform      i    Type of format
!     name       i    Name of calling subroutine
! **********************************************************************
!
!                       COMMON BLOCKS
!
! **********************************************************************
!
!                       LOCAL PARAMETERS
!
! **********************************************************************
!
!                       SUBROUTINES CALLED
!
!     ER0057    Actual error message subroutine
! **********************************************************************
!
!                       I/O
!
! **********************************************************************
!
!                       ERROR MESSAGES
!
! **********************************************************************
!
!                       PSEUDO CODE
!
! **********************************************************************
!
!                       DATA STATEMENTS
!
! ====================================================================== &
!
 99   format(///' *********  warnings in subroutine ',a,5x,'******'//)
  1   format(///' **********  warning nr.',i4,5x,'**********'/)

100   format(//' more than', i5,' warnings ')
      if(nwarn.gt.mxwarn) return
      if(iwarn.eq.0) then
         write(irefwr,99) name
      end if
      iwarn=iernr
      write(irefwr,1) iwarn
      call er0057(0,iernr,iform,i1,i2,i3,0d0,0d0,0d0)
      nwarn=nwarn+1
      if(nwarn.gt.mxwarn) write(irefwr,100) mxwarn
      end
