      subroutine iniputxt ( text, wrtrecord, ilast )
! ======================================================================
!
!        programmer     Guus Segal
!        version 1.0    date   07-03-1997
!
!
!   copyright (c) 1997-1997 "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
! **********************************************************************
!
!                       DESCRIPTION
!
!   Put text in wrtrecord from position ilast
!   Raise ilast
! **********************************************************************
!
!                       KEYWORDS
!
!    write
! **********************************************************************
!
!                       INPUT / OUTPUT PARAMETERS
!
      implicit none
      integer ilast
      character *1000 wrtrecord
      character *(*) text

!     ilast     i/o   Last position used in wrtrecord
!     text       i    text to be stored
!     wrtrecord i/o   Contains record to be written
! **********************************************************************
!
!                       COMMON BLOCKS
!
! **********************************************************************
!
!                       LOCAL PARAMETERS
!
      integer nchar

!     nchar      Number of characters in a word
! **********************************************************************
!
!                       SUBROUTINES CALLED
!
! **********************************************************************
!
!                       I/O
!
! **********************************************************************
!
!                       ERROR MESSAGES
!
! **********************************************************************
!
!                       PSEUDO CODE
!
! **********************************************************************
!
!                       DATA STATEMENTS
!
! ======================================================================
!
      nchar = len(text)
      wrtrecord(ilast+1:ilast+nchar) = text
      ilast = ilast+nchar
      end
