      subroutine prinin ( iarray, n, text )
! ======================================================================
!
!        programmer    Guus Segal
!        version  1.4  date 03-11-2008 Adaptation formats
!        version  1.3  date 09-09-2005 Adaptation formats
!        version  1.2  date 28-12-2001 Adaptation formats
!        version  1.1  date 12-06-1998 Layout
!        version  1.0  date 24-05-1990
!
!   copyright (c) 1990-2008  "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
! **********************************************************************
!
!                       DESCRIPTION
!
!     Auxiliary help subroutine only meant for debugging purposes
!     The task of prinin is to print an integer array in the
!     form   seq. number:  number etc.
! **********************************************************************
!
!                       KEYWORDS
!
!     print
! **********************************************************************
!
!                       MODULES USED
!
      use sepmodulecomio
      implicit none
! **********************************************************************
!
!                       COMMON BLOCKS
!
! **********************************************************************
!
!                       INPUT / OUTPUT PARAMETERS
!
      integer iarray(*), n
      character *(*) text

!    iarray   i  integer array to be printed
!    n        i  Number of entries of the integer array to be printed
!    text     i  Text to be printed in the heading
! **********************************************************************
!
!                       LOCAL PARAMETERS
!
      integer i

!    i          General loop variable
! **********************************************************************
!
!                       SUBROUTINES CALLED
!
! **********************************************************************
!
!                       I/O
!
! **********************************************************************
!
!                       ERROR MESSAGES
!
! **********************************************************************
!
!                       PSEUDO CODE
!
! **********************************************************************
!
!                       DATA STATEMENTS
!
! ======================================================================
!
      write ( irefwr, 100 ) text, (i,iarray(i),i=1,n)
100   format(a/(5(i6,':',i8)))

      end
