      subroutine adapbn ( inpada, rinada, kmeshlc, kproblc, isol )
      use sepmodulekmesh
      use sepmodulemain
      implicit none
      integer inpada(*), kmeshlc, kproblc, isol
      double precision rinada(*)
      integer nadapt
      parameter ( nadapt=17 )
      integer icopad(nadapt), i, lengin, lengrl, numcrv, iseqvecs(1), idummy
      logical changed, changeinput
      integer, allocatable :: iinput(:), icurvs(:)
      double precision, allocatable :: rinput(:)
      double precision :: timebefore(2)
      call eropen ( 'adapbn' )
      if ( itime>0 ) call ersettime ( timebefore )
      kmesh2d(1) = kmeshlc
      kprob2d(1) = kproblc
      kmesh => kmesh2d(1)
      kprob => kprob2d(1)

      call sepfillkmesh(kmesh)
      call msh008 ( 1, inpada, isol, icopad, nadapt, idummy )

!     --- Get arrays iinput and rinput and copy to end of idummy
!         Put control integers around both arrays

      lengin = size ( iinputkm )
      lengrl = size ( rinputkm )
      numcrv = icopad(3)-icopad(2)+1

      allocate ( iinput(lengin), rinput(lengrl), icurvs(numcrv), &
                 stat = error )
      if ( error/=0 ) &
         call eralloc ( error, lengin+lengrl+numcrv, 'iinput' )
      if ( ierror/=0 ) go to 1000

!     --- Fill array icurvs

      do i = 1, numcrv
         icurvs(i) = icopad(2)+i-1
      end do
      icopad(2) = numcrv

      iinput = iinputkm
      rinput = rinputkm

!     --- Call actual subroutine

      iseqvecs(1) = 1
      call msh056 ( icopad, rinada, isol, iinput, rinput, icurvs, &
                    1, 1, changed, changeinput, 1, iseqvecs )

      if ( .not. changeinput ) then

!     --- Copy iinput and rinput back and reset nbuffr

        iinputkm = iinput
        rinputkm = rinput

      end if

      deallocate ( iinput, rinput, icurvs, stat = error )
      if ( error/=0 ) call erdealloc ( error, 'iinput' )
      if ( ierror/=0 ) go to 1000

1000  call erclmn ( 'adapbn', timebefore )

      end subroutine adapbn
