      subroutine msh419(kelem,j,i1,i2,i3,i4,i5,i6,i7,i8,i9, &
                        i10,i11,i12,i13,i14,i15,i16,i17,i18, &
                        i19,i20,i21,i22,i23,i24,i25,i26,i27)

! =======================================================================
!
!
!         programmer   niek praagman
!
!         version 1.2    date  04-02-1993 New norms
!         version 1.1    date  22-08-1991 Zdenek: no dimension, cdc, ce
!         version 1.0    date  14-03-1989
!
!
!
!   copyright (c) 1989-1993  "ingenieursbureau sepra"
!   permission to copy or distribute this software or documentation
!   in hard or soft copy granted only by written license obtained
!   from "ingenieursbureau sepra".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system (e.g. , in memory, disk or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
!
! ***********************************************************************
!
!     DESCRIPTION
!
!     Place nodes for quadratic hexahedron in element array KELEM
!
! ***********************************************************************
!
!     KEYWORDS
!
!     hexahedron
!     quadratic
!
! ***********************************************************************
!
!     INPUT / OUTPUT PARAMETERS
!
      implicit none

      integer j, kelem(27,j), i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, &
              i11, i12, i13, i14, i15, i16, i17, i18, i19, i20, i21, &
              i22, i23, i24, i25, i26, i27

!     i1     node
!     i10
!     i11
!     i12
!     i13
!     i14
!     i15
!     i16
!     i17
!     i18
!     i19
!     i2     node
!     i20
!     i21
!     i22
!     i23
!     i24
!     i25
!     i26
!     i27
!     i3     node
!     i4     node
!     i5     node
!     i6     node
!     i7     node
!     i8     node
!     i9     node
!     j      element number
!     kelem  element array
!
! ***********************************************************************
!
!     COMMON BLOCKS
!
! ***********************************************************************
!
!     LOCAL PARAMETERS
!
! ***********************************************************************
!
!     SUBROUTINES CALLED
!
!
! ***********************************************************************
!
!     ERROR MESSAGES
!
! ***********************************************************************
!
!     METHOD
!
!     PSEUDO CODE
!
! =======================================================================

      kelem(  1,j ) =  i1
      kelem(  2,j ) =  i2
      kelem(  3,j ) =  i3
      kelem(  4,j ) =  i4
      kelem(  5,j ) =  i5
      kelem(  6,j ) =  i6
      kelem(  7,j ) =  i7
      kelem(  8,j ) =  i8
      kelem(  9,j ) = i9
      kelem( 10,j ) = i10
      kelem( 11,j ) = i11
      kelem( 12,j ) = i12
      kelem( 13,j ) = i13
      kelem( 14,j ) = i14
      kelem( 15,j ) = i15
      kelem( 16,j ) = i16
      kelem( 17,j ) = i17
      kelem( 18,j ) = i18
      kelem( 19,j ) = i19
      kelem( 20,j ) = i20
      kelem( 21,j ) = i21
      kelem( 22,j ) = i22
      kelem( 23,j ) = i23
      kelem( 24,j ) = i24
      kelem( 25,j ) = i25
      kelem( 26,j ) = i26
      kelem( 27,j ) = i27

      end
