      subroutine plbc07 ( ineigh, ib, is )
! ======================================================================
!
!
!        programmer     Niek Praagman
!        version 1.2    date  20-01-1996 New layout
!        version 1.1    date  22-08-1991 Zdenek: no dimension, cdc, ce
!        version 1.0    date  29-07-1986
!
!
!   copyright (c) 1986-1996  "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
!
!
! ********************************************************************
!
!                         DESCRIPTION
!
!    subroutine to fill node is, a neighbour of node i, in array  ineigh
!
! ***********************************************************************
!
!                      KEYWORDS
!
!   2d
!   element
!   plot_contour
! ********************************************************************
!
!                      INPUT / OUTPUT    PARAMETERS
!
      implicit none
      integer ineigh(*), ib, is

!     ib        i/o   total number of neighbours registered
!     ineigh    i/o   array containing the neighbours of node i
!     is         i    neighbour considered
! ********************************************************************
!
!                      COMMON BLOCKS
!
! ********************************************************************
!
!                    LOCAL PARAMETERS
!
      integer istep, ih

!     ih         Help variable to store a constant temporarily
!     istep
! ********************************************************************
!
!             SUBROUTINES CALLED
!
! ********************************************************************
!
!                    I/O
!
!    none
! ********************************************************************
!
!                    ERROR MESSAGES
!
! ********************************************************************
!
!                    PSEUDO CODE
!
!   trivial
! ======================================================================
!

      istep=0

100   istep=istep+1
      ih=ineigh(istep)

      if ( ih.eq.is ) go to 1000

      if ( ih.ne.0  ) goto 100

      ineigh(istep)=is
      ib=ib+1

1000  continue

      end
