      subroutine plbc17(work,work2,n,k)
      implicit double precision (a-h,o-z)
      double precision work(*), work2(*)
!
! ***********************************************************************
!                                                                       * &
!                                                                       * &
!         programmer   niek praagman                                    * &
!         version 1.1  date  22-08-1991 Zdenek: no dimension, cdc, ce
!         version 1    date  26-199-1986                                    * &
!                                                                       * &
!                                                                       * &
!                                                                       * &
!   copyright (c) 1986  "ingenieursbureau sepra"                        * &
!   permission to copy or distribute this software or documentation     * &
!   in hard or soft copy granted only by written license obtained       * &
!   from "ingenieursbureau sepra".                                      * &
!   all rights reserved. no part of this publication may be reproduced, * &
!   stored in a retrieval system (e.g. , in memory, disk or core)       * &
!   or be transmitted by any means, electronic, mechanical, photocopy,  * &
!   recording, or otherwise, without written permission from the        * &
!   publisher.                                                          * &
!                                                                       * &
! ***********************************************************************
! *                                                                     * &
! * PLBC17 computes the right hand side of the system of equations      * &
! * to be solved for discrete cubic spline smoothing                    * &
! * the r.h.s. is stored in positions ipc+i , i=1(1)n-1 of array work2  * &
! *                                                                     * &
! ***********************************************************************
! *                                                                     * &
! *   parameters : see PLBC14                                           * &
! *                                                                     * &
! ***********************************************************************
! * &
      kp4  =k+4
      ipc  =5+kp4*n
      ipcp1=ipc+1
      iph  =5+8*n
      nm1  =n-1
! * &
      work2(ipc+1)=(work(1+k)-work(2*n+k-3))/work2(iph+nm1)
! * &
      do 100 i=1,nm1
          ih=2*i+k-1
          work2(ipcp1+i)=(work(ih+2)-work(ih))/work2(iph+i)
100   continue
! * &
! *   store components of rhs
! * &
      do 200 i=1,nm1
          work2(ipc+i)=3*(work2(ipcp1+i)-work2(ipc+i))
200   continue
! * &
      end
