      subroutine plt355(x1,x2,x3,y1,y2,y3,x,y,ski1,ski2,ski3)
      implicit double precision (a-h,o-z)
! * &
! ***********************************************************************
! *                                                                     * &
! *   Subroutine to compute the area coordinates for point              * &
! *   ( x,y ) in triangle 1 - 2 - 3 .                                   * &
! *                                                                     * &
! ***********************************************************************
!                                                                       * &
!                                                                       * &
!         programmer   niek praagman                                    * &
!         version 1    date  27-6-1987                                    * &
!                                                                       * &
!                                                                       * &
!                                                                       * &
!   copyright (c) 1987  "ingenieursbureau sepra"                        * &
!   permission to copy or distribute this software or documentation     * &
!   in hard or soft copy granted only by written license obtained       * &
!   from "ingenieursbureau sepra".                                      * &
!   all rights reserved. no part of this publication may be reproduced, * &
!   stored in a retrieval system (e.g. , in memory, disk or core)       * &
!   or be transmitted by any means, electronic, mechanical, photocopy,  * &
!   recording, or otherwise, without written permission from the        * &
!   publisher.                                                          * &
!                                                                       * &
! ***********************************************************************
! *                                                                     * &
! *   Meaning of parameters :                                           * &
! *                                                                     * &
! *   ( xi,yi )        (i)  : coordinates of point i in triangle        * &
! *   ( x , y )        (i)  : point to be considered                    * &
! *   (ski1,ski2,ski3) (o)  : area coordinates                          * &
! *                                                                     * &
! ***********************************************************************
! * &
! *   Compute area
! * &
      surfac = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
! * &
      ski1 = ( x2*y3 - x3*y2 + (y2-y3)*x + (x3-x2)*y ) / surfac
      ski2 = ( x3*y1 - x1*y3 + (y3-y1)*x + (x1-x3)*y ) / surfac
      ski3 = ( x1*y2 - x2*y1 + (y1-y2)*x + (x2-x1)*y ) / surfac
! * &
      end
