      subroutine pltjfm ( fval, nfpnt, fmin, fmax )
! ======================================================================
!
!
!        programmer     Jos van Kan
!        version 1.0    date   20-01-1995
!
!
!
!   copyright (c) 1995-1995 "Ingenieursbureau SEPRA"
!   permission to copy or distribute this software or documentation
!   in hard copy or soft copy granted only by written license
!   obtained from "Ingenieursbureau SEPRA".
!   all rights reserved. no part of this publication may be reproduced,
!   stored in a retrieval system ( e.g., in memory, disk, or core)
!   or be transmitted by any means, electronic, mechanical, photocopy
!   recording, or otherwise, without written permission from the
!   publisher.
!
!
! ********************************************************************
!
!                         DESCRIPTION
!
!       pltjfm finds the maximum and minimum value in array fval
!
! ********************************************************************
!
!                      KEYWORDS
!
!
! ********************************************************************
!
!                      INPUT / OUTPUT    PARAMETERS
!
      implicit none
      integer nfpnt
      double precision fval (nfpnt), fmax, fmin

!     fmax    o    maximum function value
!     fmin    o    minimum function value
!     fval    i    function values in nodes
!     nfpnt   i    number of function values
! ********************************************************************
!
!                      COMMON BLOCKS
!
! ********************************************************************
!
!                      LOCAL PARAMETERS
!
      integer ifpnt

!     ifpnt   ?
! ********************************************************************
!
!                      SUBROUTINES CALLED
!
! ********************************************************************
!
!                      I/O
!
! ********************************************************************
!
!                      ERROR MESSAGES
!
! ********************************************************************
!
!                      PSEUDO CODE
!
!   trivial
! ======================================================================
!
      fmin = fval (1)
      fmax = fval (1)
      do 100 ifpnt = 1, nfpnt
         if (fval (ifpnt).gt.fmax) fmax = fval (ifpnt)
         if (fval (ifpnt).lt.fmin) fmin = fval (ifpnt)
100   continue
      end
