      subroutine el6026(f, vec1, vec2, m)

!***********************************************************************
!
!     Programmer Luc Timmermans
!     version 1.0   date 12-08-1992
!
!***********************************************************************
!
!     compose f out of vec1 and vec2
!
!***********************************************************************
!
!     INPUT/OUTPUT PARAMETERS

      implicit none

      integer m
      double precision f(2*m), vec1(m), vec2(m)
!
!     m         i     number of integration points
!     f         o     resulting vector
!     vec1      i     first input vector
!     vec2      i     second input vector
!
!***********************************************************************
!
!     LOCAL PARAMETERS

      integer i
!
!     i    counting parameter
!
!***********************************************************************

      do 100 i = 1, m

         f(2*i-1) = vec1(i)
         f(2*i) = vec2(i)
100   continue

      end
