      program rotat02

!     --- Main program for testing of upwind schemes for 2d convection-diffusion
!         linear triangular elements, with limiting
!         See manual standard problems, Section 3.1.8.2
!         Rotating cone problem

      call startsepcomp

      end

!     --- define velocity as function of the co-ordinates

      function funccf ( ichoice, x, y, z )
      implicit none
      integer ichoice
      double precision x, y, z, funccf

      if ( ichoice==1 ) then

!     --- ichoice = 1, u = -y

         funccf = -y

      else if ( ichoice==2 ) then

!     --- ichoice = 2, v = x

         funccf = x

      else

!     --- Other case, should never be possible

         funccf = 0d0

      end if

      end

!     --- define concentration as boundary condition on curve c2

      function funcbc ( ichoice, x, y, z )
      use sepmoduleconsts
      implicit none
      integer ichoice
      double precision x, y, z, funcbc

      if ( ichoice==1 ) then

!     --- ichoice = 1, c = cos(2pi (y+0.25))

         funcbc = cos(2d0*pi*(y+0.25d0))

      else

!     --- Other case, should never be possible

         funcbc = 0d0

      end if

      end
