      program opgave1_1
      integer, allocatable, dimension (:) :: ibuffr
      integer (kind=8) pbuffr
      integer error
      parameter ( pbuffr=100000000)
      allocate(ibuffr(pbuffr), stat = error)
      if (error /= 0) then
         ! space for these arrays could not be allocated
         print *, "error: (sepcompexe) could not allocate space."
         stop
      end if  ! (error /= 0)
      call sepcombf ( ibuffr, ibuffr, pbuffr )
      end

      function funccf ( ifunc, x, y, z )
      use sepmoduletime
      implicit none
      integer ifunc
      double precision funccf, x, y, z
      double precision rho
      double precision getconst

      rho = getconst('rho')

      select case ( ifunc )
      case(1)

!     --- Special option, preprogrammed already

         funccf = y/rho

      case default

!     --- Option not programmed yet

         call errchr ( 'funccf', 1 )
         call errint ( ifunc, 1 )
         call errsub ( 1930, 1, 0, 1 )
         call instop

      end select  ! case ( ifunc )

      end
