      program matlabmesh
c ======================================================================
c
c        programmer    Guus Segal
c        version  1.0  date 02-04-2002
c
c   copyright (c) 2002-2002  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c **********************************************************************
c
c                       DESCRIPTION
c
c   Main program for the writing of a sepran mesh such that all
c   the necessary information is stored to be read by matlab
c   It concerns the special case of unstructured finite volumes,
c   which requires a special dataset
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       MODULES USED
c
      implicit none
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     WRITE_MESH_ML  Body of program matlabmesh
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call startsepran
      call write_mesh_ml ( ibuffr, ibuffr, nbuffr )
      end
