      subroutine fil150 ( ielgrp, iuser, user, kproblc, nparm, iwork, &
                          work )
      use sepmodulemain
      use sepmodulekprob
      use sepmodulekmesh
      implicit none
      integer iuser(*), kproblc, iwork(*), ielgrp, nparm
      double precision user(*), work(*)
      integer nelgrptot, icount, jcount, i, ifunc
      call eropen ( 'fil150' )
      kprob2d(1) = kproblc
      kprob => kprob2d(1)
      if( ielgrp.gt.nelgrp ) then
         call errint ( ielgrp, 1 )
         call errint ( nelgrp, 2 )
         call errsub ( 415, 2, 0, 0 )
      end if
      if(ielgrp.eq.1 .or. iuser(2).le.0) then

!     --- ielgrp = 1

        nelgrptot = nelgrp+numnat
        icount = 5+nelgrptot
        jcount = 5
      else

!     --- ielgrp > 1

        icount = iuser(4)
        jcount = nint(user(4))

      end if

!     --- fill arrays iuser and user

      iuser(ielgrp+5) = icount+1

      do i = 1, nparm
         ifunc = iwork(i)
         call elf001 ( icount, jcount, ifunc, work(2*i-1), i, iuser, &
                       user )
      end do
      iuser(4) = icount
      user(4) = jcount
      iuser(2) = ielgrp
      iuser(3) = max(iuser(3),icount)
      user(3) = max(nint(user(3)),jcount)
      if ( user(1).lt.jcount+1 ) &
           call prinlg ( 'user', -jcount-1, user, iuser )
      if ( iuser(1).lt.icount+1 ) &
           call prinlg ( 'iuser', icount+1, user, iuser )
      call erclos ( 'fil150' )
      if ( ierror.ne.0 ) call instop
      end
